namespace Programming_CSharp
{
	using System;
	using System.Diagnostics;
	using System.IO;
	using System.Reflection;
	using System.Reflection.Emit;
	using System.Threading;

	// ġŷ Ǵ  
	public class MyMath
	{
		//  ̿Ͽ  Ѵ.
		public int DoSumLooping(int initialVal)
		{
			int result = 0;
			for(int i = 1;i <=initialVal;i++)
			{
				result += i;
			}
			return result;
		}
	}

	// ̽ 
	public interface IComputer
	{
		int ComputeSum();
	}

	public class ReflectionTest
	{
		// op ڵ带 Ͽ 
		//  ϴ  ޼ҵ 
		private Assembly EmitAssembly(int theValue)
		{
			//  ̸ Ѵ.
			AssemblyName assemblyName = 
				new AssemblyName();
			assemblyName.Name = "DoSumAssembly";

			//  ο  Ѵ.
			AssemblyBuilder newAssembly =
				Thread.GetDomain().DefineDynamicAssembly(
				assemblyName, AssemblyBuilderAccess.Run);
			ModuleBuilder newModule =
				newAssembly.DefineDynamicModule("Sum");

			//  ȿ BruteForceSums  Ŭ Ѵ.
			TypeBuilder myType =
				newModule.DefineType(
				"BruteForceSums", TypeAttributes.Public);

			// IComputer ϴ Ŭ ǥѴ.
			myType.AddInterfaceImplementation(
				typeof(IComputer));

			// ȣ ŸԿ ޼ҵ带 Ѵ.
			// Ű Ÿ԰ ȯ Ÿ, ޼ҵ ̸, ޼ҵ Ӽ
			// ϴ 迭 Ѵ.
			Type[] paramTypes = new Type[0];
			Type returnType = typeof(int);
			MethodBuilder simpleMethod =
				myType.DefineMethod(
				"ComputeSum",
				MethodAttributes.Public | 
				MethodAttributes.Virtual,
				returnType,
				paramTypes);

			// ILGenerator  ´.
			// ̰ ϴ IL ϱ  ȴ.
			ILGenerator generator = 
				simpleMethod.GetILGenerator();


			// ڵ带   IL ϰ, 
			//   Ͽ ILDasm Ѵ.

			// 0 ÿ Ѵ.
			// theValue  i   i ÿ Ѵ.
			//  ڸ  ֻ ϰ, 
			//  ÿ ȴ. 
			generator.Emit(OpCodes.Ldc_I4, 0);
			for (int i = 1; i <= theValue;i++)
			{
				generator.Emit(OpCodes.Ldc_I4, i);
				generator.Emit(OpCodes.Add);

			}

			//  ȯѴ. 
			generator.Emit(OpCodes.Ret);

			// ޼ҵ忡   ĸȭϰ,
			// ޼ҵ ŸͿ   ֵ Ѵ.
			MethodInfo computeSumInfo =
				typeof(IComputer).GetMethod("ComputeSum");

			// ޼ҵ  Ѵ. 
			// DefineMethod methodInfo ȣϿ 
			// ȯǴ MethodBuilder Ѵ. 
			myType.DefineMethodOverride(simpleMethod, computeSumInfo);

			// Ÿ Ѵ. 
			myType.CreateType();
			return newAssembly;
		}

		// ̽  ˻ϰ,
		//  쿡 Setup ȣѴ. 
		public double DoSum(int theValue)
		{
			if (theComputer == null)
			{
				GenerateCode(theValue);
			}

			// ̽  ޼ҵ ȣ 
			return (theComputer.ComputeSum());
		}

		//  ϰ, 
		// νϽ Ͽ ̽ Ѵ.
		public void GenerateCode(int theValue)
		{
			Assembly theAssembly = EmitAssembly(theValue);
			theComputer = (IComputer) 
				theAssembly.CreateInstance("BruteForceSums");
		}

		//    
		IComputer theComputer = null;

	}

	public class TestDriver
	{
		public static void Main()
		{
			const int val = 2000;  //  2000  Ѵ.

			// 鸸  ݺѴ. 
			const int iterations = 1000000;
			double result = 0;

			// ġũ  
			MyMath m = new MyMath(); 
			DateTime startTime = DateTime.Now; 
			for (int i = 0;i < iterations;i++)
			{
				result = m.DoSumLooping(val);
			}
			TimeSpan elapsed = 
				DateTime.Now - startTime;
			Console.WriteLine(
				"Sum of ({0}) = {1}",val, result);
			Console.WriteLine(
				"Looping. Elapsed milliseconds: \n" + 
				elapsed.TotalMilliseconds + 
				" for {0} iterations", iterations);

			//  ٸ ݿ Ѵ.
			ReflectionTest t = new ReflectionTest();

			startTime = DateTime.Now; 
			for (int i = 0;i < iterations;i++)
			{
				result = t.DoSum(val);
			}

			elapsed = DateTime.Now - startTime;
			Console.WriteLine(
				"Sum of ({0}) = {1}",val, result);
			Console.WriteLine(
				"Brute Force. Elapsed milliseconds: \n" + 
				elapsed.TotalMilliseconds  + 
				" for {0} iterations", iterations);
		}
	}
}

